# coding: utf-8

"""
    STACKIT DNS API

    This api provides dns

    The version of the OpenAPI document: 1.0
    Contact: stackit-dns@mail.schwarz
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501 docstring might be too long

from __future__ import annotations

import json
import pprint
from typing import Any, ClassVar, Dict, List, Optional, Set

from pydantic import (
    BaseModel,
    ConfigDict,
    Field,
    StrictBool,
    StrictStr,
    field_validator,
)
from typing_extensions import Annotated, Self


class CreateZonePayload(BaseModel):
    """
    Zone to create.
    """

    acl: Optional[Annotated[str, Field(strict=True, max_length=2000)]] = Field(
        default="0.0.0.0/0,::/0", description="access control list"
    )
    contact_email: Optional[Annotated[str, Field(strict=True, max_length=255)]] = Field(
        default="hostmaster@stackit.cloud", description="contact e-mail for the zone", alias="contactEmail"
    )
    default_ttl: Optional[Annotated[int, Field(strict=True, ge=60)]] = Field(
        default=None, description="default time to live", alias="defaultTTL"
    )
    description: Optional[Annotated[str, Field(strict=True, max_length=1024)]] = Field(
        default=None, description="description of the zone"
    )
    dns_name: Annotated[str, Field(min_length=1, strict=True, max_length=253)] = Field(
        description="zone name", alias="dnsName"
    )
    expire_time: Optional[Annotated[int, Field(strict=True, ge=60)]] = Field(
        default=None, description="expire time", alias="expireTime"
    )
    is_reverse_zone: Optional[StrictBool] = Field(
        default=False, description="if the zone is a reverse zone or not", alias="isReverseZone"
    )
    name: Annotated[str, Field(min_length=1, strict=True, max_length=63)] = Field(description="user given name")
    negative_cache: Optional[Annotated[int, Field(strict=True, ge=60)]] = Field(
        default=None, description="negative caching", alias="negativeCache"
    )
    primaries: Optional[List[StrictStr]] = Field(default=None, description="primary name server for secondary zone")
    refresh_time: Optional[Annotated[int, Field(strict=True, ge=60)]] = Field(
        default=None, description="refresh time", alias="refreshTime"
    )
    retry_time: Optional[Annotated[int, Field(strict=True, ge=60)]] = Field(
        default=None, description="retry time", alias="retryTime"
    )
    type: Optional[StrictStr] = Field(default="primary", description="zone type")
    __properties: ClassVar[List[str]] = [
        "acl",
        "contactEmail",
        "defaultTTL",
        "description",
        "dnsName",
        "expireTime",
        "isReverseZone",
        "name",
        "negativeCache",
        "primaries",
        "refreshTime",
        "retryTime",
        "type",
    ]

    @field_validator("type")
    def type_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in set(["primary", "secondary"]):
            raise ValueError("must be one of enum values ('primary', 'secondary')")
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of CreateZonePayload from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of CreateZonePayload from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate(
            {
                "acl": obj.get("acl") if obj.get("acl") is not None else "0.0.0.0/0,::/0",
                "contactEmail": (
                    obj.get("contactEmail") if obj.get("contactEmail") is not None else "hostmaster@stackit.cloud"
                ),
                "defaultTTL": obj.get("defaultTTL"),
                "description": obj.get("description"),
                "dnsName": obj.get("dnsName"),
                "expireTime": obj.get("expireTime"),
                "isReverseZone": obj.get("isReverseZone") if obj.get("isReverseZone") is not None else False,
                "name": obj.get("name"),
                "negativeCache": obj.get("negativeCache"),
                "primaries": obj.get("primaries"),
                "refreshTime": obj.get("refreshTime"),
                "retryTime": obj.get("retryTime"),
                "type": obj.get("type") if obj.get("type") is not None else "primary",
            }
        )
        return _obj
